package org.jenkinsci.plugins.p4_client.connection;

import hudson.DescriptorExtensionList;
import hudson.ExtensionPoint;
import hudson.model.Describable;
import hudson.model.Hudson;

public abstract class ConnectionProvider implements ExtensionPoint,
		Describable<ConnectionProvider> {

	public ConnectionDescriptor getDescriptor() {
		return (ConnectionDescriptor) Hudson.getInstance().getDescriptor(
				getClass());
	}

	public static DescriptorExtensionList<ConnectionProvider, ConnectionDescriptor> all() {
		return Hudson.getInstance()
				.<ConnectionProvider, ConnectionDescriptor> getDescriptorList(
						ConnectionProvider.class);
	}
}
